// PolyDrawControlView.cpp : implementation of the CPolyDrawControlView class
//

#include "stdafx.h"
#include "resource.h"

#include "PolyDrawExplorerDoc.h"
#include "PolyDrawControlView.h"
#include "ToString.h"
#include "ErrorString.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CPolyDrawControlView

IMPLEMENT_DYNCREATE(CPolyDrawControlView, CFormView)

BEGIN_MESSAGE_MAP(CPolyDrawControlView, CFormView)
    ON_BN_CLICKED(IDC_ADD, OnBnClickedAdd)
    ON_NOTIFY(LVN_ODSTATECHANGED, IDC_DATA, OnLvnOdstatechangedData)
    ON_BN_CLICKED(IDC_MOVETO, OnBnClickedMoveto)
    ON_BN_CLICKED(IDC_LINETO, OnBnClickedLineto)
    ON_BN_CLICKED(IDC_BEZIERTO, OnBnClickedBezierto)
    ON_BN_CLICKED(IDC_CLOSEFIGURE, OnBnClickedClosefigure)
    ON_BN_CLICKED(IDC_UP, OnBnClickedUp)
    ON_BN_CLICKED(IDC_DOWN, OnBnClickedDown)
    ON_EN_CHANGE(IDC_X, OnEnChangeX)
    ON_EN_CHANGE(IDC_Y, OnEnChangeY)
    ON_BN_CLICKED(IDC_DELETE, OnBnClickedDelete)
    ON_NOTIFY(LVN_ITEMCHANGED, IDC_DATA, OnLvnItemchangedData)
    ON_WM_SIZE()
END_MESSAGE_MAP()

// CPolyDrawControlView construction/destruction

CPolyDrawControlView::CPolyDrawControlView()
        : CFormView(CPolyDrawControlView::IDD)
{
      Setting = FALSE;
      initialized = FALSE;

}

CPolyDrawControlView::~CPolyDrawControlView()
{
}

/****************************************************************************
*                    CPolyDrawControlView::DoDataExchange
* Inputs:
*       CDataExchange * pDX:
* Result: void
*       
* Effect: 
*       Binds controls to variables
****************************************************************************/

void CPolyDrawControlView::DoDataExchange(CDataExchange* pDX)
{
CFormView::DoDataExchange(pDX);
DDX_Control(pDX, IDC_DATA, c_Data);
DDX_Control(pDX, IDC_STATUS, c_Status);
DDX_Control(pDX, IDC_X, c_X);
DDX_Control(pDX, IDC_Y, c_Y);
DDX_Control(pDX, IDC_SPIN_X, c_SpinX);
DDX_Control(pDX, IDC_SPIN_Y, c_SpinY);
DDX_Control(pDX, IDC_LINETO, c_LineTo);
DDX_Control(pDX, IDC_MOVETO, c_MoveTo);
DDX_Control(pDX, IDC_BEZIERTO, c_BezierTo);
DDX_Control(pDX, IDC_CLOSEFIGURE, c_CloseFigure);
DDX_Control(pDX, IDC_ADD, c_Add);
DDX_Control(pDX, IDC_UP, c_Up);
DDX_Control(pDX, IDC_DOWN, c_Down);
DDX_Control(pDX, IDC_DELETE, c_Delete);
}


/****************************************************************************
*                    CPolyDrawControlView::PreCreateWindow
* Inputs:
*       CREATESTRUCT & cs:
* Result: BOOL
*       
* Effect: 
*       
****************************************************************************/

BOOL CPolyDrawControlView::PreCreateWindow(CREATESTRUCT& cs)
{
        // TODO: Modify the Window class or styles here by modifying
        //  the CREATESTRUCT cs

        return CFormView::PreCreateWindow(cs);
}


/****************************************************************************
*                    CPolyDrawControlView::OnInitialUpdate
* Result: void
*       
* Effect: 
*       Initializes the view
****************************************************************************/

void CPolyDrawControlView::OnInitialUpdate()
   {
    CFormView::OnInitialUpdate();
    ResizeParentToFit();
    CString caption;
    caption.LoadString(IDS_NUMBER_CAPTION);
    c_Data.InsertColumnEx(CPolyDrawCtrl::COL_NUM, caption, DT_LEFT, _T("000"));
    caption.LoadString(IDS_X_CAPTION);
    c_Data.InsertColumnEx(CPolyDrawCtrl::COL_X, caption, DT_RIGHT, _T("0000"));
    caption.LoadString(IDS_Y_CAPTION);
    c_Data.InsertColumnEx(CPolyDrawCtrl::COL_Y, caption, DT_RIGHT, _T("0000"));
    caption.LoadString(IDS_TYPE_CAPTION);
    c_Data.InsertColumnEx(CPolyDrawCtrl::COL_TYPE, caption, DT_RIGHT, _T("PT_BEZIERTO"));
    caption.LoadString(IDS_CLOSEFIGURE_CAPTION);
    c_Data.InsertColumnEx(CPolyDrawCtrl::COL_CLOSEFIGURE, caption, DT_RIGHT, _T("X"));

    c_SpinX.SetRange32(0, 1024);
    c_SpinY.SetRange32(0, 1024);
    CheckRadioButton(IDC_MOVETO, IDC_BEZIERTO, IDC_MOVETO);

    c_Up.LoadBitmaps(IDB_UP, 0, IDB_UP_DISABLED);
    c_Down.LoadBitmaps(IDB_DOWN, 0, IDB_DOWN_DISABLED);

    DocumentToItems();
    initialized = TRUE;
    updateControls();
   }

// CPolyDrawControlView diagnostics

#ifdef _DEBUG
void CPolyDrawControlView::AssertValid() const
{
        CFormView::AssertValid();
}

void CPolyDrawControlView::Dump(CDumpContext& dc) const
{
        CFormView::Dump(dc);
}
#endif

#ifdef _DEBUG
CPolyDrawExplorerDoc* CPolyDrawControlView::GetDocument() const // non-debug version is inline
{
        ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPolyDrawExplorerDoc)));
        return (CPolyDrawExplorerDoc*)m_pDocument;
}
#endif //_DEBUG

/****************************************************************************
*                     CPolyDrawControlView::GetTypeString
* Inputs:
*       BYTE flags: Flags value
* Result: CString
*       
****************************************************************************/

CString CPolyDrawControlView::GetTypeString(BYTE flags)
    {
     CString s;
     if( (flags & ~PT_CLOSEFIGURE) == PT_MOVETO)
        s = _T("PT_MOVETO");
     else
     if( (flags & ~PT_CLOSEFIGURE) == PT_LINETO)
        s = _T("PT_LINETO");
     else
     if( (flags & ~PT_CLOSEFIGURE) == PT_BEZIERTO)
        s = _T("PT_BEZIERTO");

     if(flags & PT_CLOSEFIGURE)
        s += _T("| PT_CLOSEFIGURE");

     return s;
    } // CPolyDrawControlView::GetTypeString

/****************************************************************************
*                     CPolyDrawControlView::GetTypeFlags
* Result: BYTE
*       Type flags
****************************************************************************/

BYTE CPolyDrawControlView::GetTypeFlags()
    {
     BYTE flags = 0;
     if(c_MoveTo.GetCheck() == BST_CHECKED)
        flags = PT_MOVETO;
     else
     if(c_LineTo.GetCheck() == BST_CHECKED)
        flags = PT_LINETO;
     else
     if(c_BezierTo.GetCheck() == BST_CHECKED)
        flags = PT_BEZIERTO;

     if(c_CloseFigure.GetCheck() == BST_CHECKED)
        flags |= PT_CLOSEFIGURE;
     return flags;
    } // CPolyDrawControlView::GetTypeFlags


/****************************************************************************
*                    CPolyDrawControlView::OnBnClickedAdd
* Result: void
*       
* Effect: 
*       Adds the current data to the control
****************************************************************************/

void CPolyDrawControlView::OnBnClickedAdd()
    {
     PolyDrawItem * pi = new PolyDrawItem;
     
     int n = c_Data.InsertItem(pi);

     ControlsToItem(n);
    }

/****************************************************************************
*                    CPolyDrawControlView::ControlsToItem
* Inputs:
*       int item: Item
* Result: void
*       
* Effect: 
*       Updates the item from the controls
****************************************************************************/

void CPolyDrawControlView::ControlsToItem(int item)
    {
     PolyDrawItem * pi = (PolyDrawItem *)c_Data.GetItemData(item);
     pi->pt.x = c_SpinX.GetPos32();
     pi->pt.y = c_SpinY.GetPos32();
     pi->type = GetTypeFlags();
     c_Data.Invalidate(item);
     GetDocument()->SetModifiedFlag(TRUE);
    } // CPolyDrawControlView::ControlsToItem


/****************************************************************************
*                    CPolyDrawControlView::ItemToControls
* Inputs:
*       int item:
* Result: void
*       
* Effect: 
*       Transfers the state of the item to the controls
****************************************************************************/

void CPolyDrawControlView::ItemToControls(int item)
    {
     Setting = TRUE;
     PolyDrawItem * pi = (PolyDrawItem*)c_Data.GetItemData(item);
     c_SpinX.SetPos(pi->pt.x);
     c_SpinY.SetPos(pi->pt.y);

     UINT id = 0;
     if( (pi->type & ~PT_CLOSEFIGURE) == PT_MOVETO)
        id = IDC_MOVETO;
     else
     if( (pi->type & ~PT_CLOSEFIGURE) == PT_LINETO)
        id = IDC_LINETO;
     else
     if( (pi->type & ~PT_CLOSEFIGURE) == PT_BEZIERTO)
        id = IDC_BEZIERTO;
     if(id != 0)
        CheckRadioButton(IDC_MOVETO, IDC_BEZIERTO, id);

     c_CloseFigure.SetCheck( (pi->type & PT_CLOSEFIGURE) ? BST_CHECKED : BST_UNCHECKED);

     Setting = FALSE;
    } // CPolyDrawControlView::ItemToControls

/****************************************************************************
*                CPolyDrawControlView::OnLvnOdstatechangedData
* Inputs:
*       NMHDR * pNMHDR:
*       LRESULT * pResult:
* Result: void
*       
* Effect: 
*       Moves the data from the selection to the controls
****************************************************************************/

void CPolyDrawControlView::OnLvnOdstatechangedData(NMHDR *pNMHDR, LRESULT *pResult)
    {
    LPNMLVODSTATECHANGE pStateChanged = reinterpret_cast<LPNMLVODSTATECHANGE>(pNMHDR);
    if(pStateChanged->uNewState & LVIS_SELECTED)
        { /* new selection */
         ItemToControls(pStateChanged->iFrom);
        } /* new selection */
    updateControls();
    *pResult = 0;
    }

/****************************************************************************
*                    CPolyDrawControlView::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CPolyDrawControlView::updateControls()
    {
     if(!initialized)
        return;
     
     UINT show = SW_SHOW;
     if(c_MoveTo.GetCheck() == BST_CHECKED)
        show = SW_HIDE;
     c_CloseFigure.ShowWindow(show);

     int n = GetSelectedItem();
     if(n < 0)
        { /* no selection */
         c_Up.EnableWindow(FALSE);
         c_Down.EnableWindow(FALSE);
        } /* no selection */
     else
        { /* has selection */
         if(n == 0)
            c_Up.EnableWindow(FALSE);
         else
            c_Up.EnableWindow(TRUE);
         if(n == c_Data.GetItemCount() - 1)
            c_Down.EnableWindow(FALSE);
         else
            c_Down.EnableWindow(TRUE);
        } /* has selection */

     if(GetSelectedItem() < 0)
        c_Delete.EnableWindow(FALSE);
     else
        c_Delete.EnableWindow(TRUE);
     
     // Now force a redraw
     ItemsToDocument();
     
     GetDocument()->UpdateAllViews(this);
    } // CPolyDrawControlView::updateControls

/****************************************************************************
*                    CPolyDrawControlView::DocumentToItems
* Result: void
*       
* Effect: 
*       Moves the document to the controlsn
****************************************************************************/

void CPolyDrawControlView::DocumentToItems()
    {
     int size = GetDocument()->GetCount();
     if(size == 0)
        return;
     
     for(int i = 0; i < size; i++)
        { /* set types */
         PolyDrawItem * pi = GetDocument()->GetPolyDrawItem(i);
         c_Data.InsertItem(pi);
        } /* set types */
    } // CPolyDrawControlView::DocumentToItems

/****************************************************************************
*                    CPolyDrawControlView::ItemsToDocument
* Result: void
*       
* Effect: 
*       Copies all items to the document
****************************************************************************/

void CPolyDrawControlView::ItemsToDocument()
    {
     GetDocument()->SetDataSize(c_Data.GetItemCount());
     for(int i = 0; i < c_Data.GetItemCount(); i++)
        { /* scan items */
         PolyDrawItem * pi = (PolyDrawItem *)c_Data.GetItemData(i);
         GetDocument()->SetData(i, pi);
         if(i == GetSelectedItem())
            GetDocument()->SetActive(pi->pt);
        } /* scan items */
    } // CPolyDrawControlView::ItemsToDocument

/****************************************************************************
*                   CPolyDrawControlView::OnBnClickedMoveto
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CPolyDrawControlView::OnBnClickedMoveto()
    {
     UpdateSelection();
    }

/****************************************************************************
*                   CPolyDrawControlView::OnBnClickedLineto
* Result: void
*       
* Effect: 
*       Update the controls
****************************************************************************/

void CPolyDrawControlView::OnBnClickedLineto()
    {
     UpdateSelection();
    }

/****************************************************************************
*                CPolyDrawControlView::OnBnClickedBezierto
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CPolyDrawControlView::OnBnClickedBezierto()
    {
     UpdateSelection();
    }

/****************************************************************************
*                 CPolyDrawControlView::OnBnClickedClosefigure
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CPolyDrawControlView::OnBnClickedClosefigure()
    {
     UpdateSelection();
    }

/****************************************************************************
*                    CPolyDrawControlView::GetSelectedItem
* Result: int
*       Selected item, -1 if none
* Notes: 
*       Since this is specified as a single-selection view, there is only
*       one possible selection
****************************************************************************/

int CPolyDrawControlView::GetSelectedItem()
    {
     POSITION p = c_Data.GetFirstSelectedItemPosition();
     if(p == NULL)
        return -1;

     return c_Data.GetNextSelectedItem(p);
    } // CPolyDrawControlView::GetSelectedItem

/****************************************************************************
*                       CPolyDrawControlView::SwapItems
* Inputs:
*       int i1:
*       int i2:
* Result: void
*       
* Effect: 
*       Swaps item 1 and item 2
****************************************************************************/

void CPolyDrawControlView::SwapItems(int i1, int i2)
    {
     PolyDrawItem * d1 = (PolyDrawItem*)c_Data.GetItemData(i1);
     PolyDrawItem * d2 = (PolyDrawItem*)c_Data.GetItemData(i2);
     
     c_Data.SetItemData(i1, (DWORD_PTR)d2);
     c_Data.SetItemData(i2, (DWORD_PTR)d1);
     c_Data.Invalidate(i1);
     c_Data.Invalidate(i2);
    } // CPolyDrawControlView::SwapItems

/****************************************************************************
*                     CPolyDrawControlView::OnBnClickedUp
* Result: void
*       
* Effect: 
*       Moves the current selection up
****************************************************************************/

void CPolyDrawControlView::OnBnClickedUp()
    {
     int n = GetSelectedItem();
     if(n <= 0)
        return;

     SwapItems(n, n - 1);
     c_Data.SetItemState(n, 0, LVIS_SELECTED);
     c_Data.SetItemState(n - 1, LVIS_SELECTED, LVIS_SELECTED);
     updateControls();
    }

/****************************************************************************
*                    CPolyDrawControlView::OnBnClickedDown
* Result: void
*       
* Effect: 
*       Moves it down
****************************************************************************/

void CPolyDrawControlView::OnBnClickedDown()
    {
     int n = GetSelectedItem();
     if(n < 0)
        return;
     if(n >= c_Data.GetItemCount())
        return;
     
     SwapItems(n, n + 1);
     c_Data.SetItemState(n, 0, LVIS_SELECTED);
     c_Data.SetItemState(n + 1, LVIS_SELECTED, LVIS_SELECTED);
     updateControls();
    }

/****************************************************************************
*                    CPolyDrawControlView::UpdateSelection
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CPolyDrawControlView::UpdateSelection()
    {
     int item = GetSelectedItem();
     if(item >= 0)
        ControlsToItem(item);
     updateControls();
    } // CPolyDrawControlView::UpdateSelection

/****************************************************************************
*                      CPolyDrawControlView::OnEnChangeX
* Result: void
*       
* Effect: 
*       Handles change of the X-coordinate
****************************************************************************/

void CPolyDrawControlView::OnEnChangeX()
    {
     if(!initialized)
        return;
     
     if(Setting)
        return;
     
     UpdateSelection();
    }

/****************************************************************************
*                      CPolyDrawControlView::OnEnChangeY
* Result: void
*       
* Effect: 
*       Handles change of the Y-coordinate
****************************************************************************/

void CPolyDrawControlView::OnEnChangeY()
    {
     if(!initialized)
        return;
     if(Setting)
        return;

     UpdateSelection();
    }


/****************************************************************************
*                   CPolyDrawControlView::OnBnClickedDelete
* Result: void
*       
* Effect: 
*       Deletes the selectio
****************************************************************************/

void CPolyDrawControlView::OnBnClickedDelete()
    {
     int item = GetSelectedItem();
     if(item < 0)
        return;
     c_Data.DeleteItem(item);
     updateControls();
    }



/****************************************************************************
*                  CPolyDrawControlView::OnLvnItemchangedData
* Inputs:
*       NMHDR * pNMHDR: (NMHDR*)(LPNMLISTVIEW)
*       LRESULT * pResult:
* Result: void
*       
* Effect: 
*       Deals with change in selection
****************************************************************************/

void CPolyDrawControlView::OnLvnItemchangedData(NMHDR *pNMHDR, LRESULT *pResult)
    {
     UNREFERENCED_PARAMETER(pNMHDR);
     //LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
     int item = GetSelectedItem();
     if(item >= 0)
        ItemToControls(item);
     updateControls();
     *pResult = 0;
    }

/****************************************************************************
*                         CPolyDrawControlView::OnSize
* Inputs:
*       UINT nType:
*       int cx:
*       int cy:
* Result: void
*       
* Effect: 
*       Resizes the controls
****************************************************************************/

void CPolyDrawControlView::OnSize(UINT nType, int cx, int cy)
    {
     CFormView::OnSize(nType, cx, cy);

     if(c_Data.GetSafeHwnd() != NULL)
        { /* resize data */
         CRect r;
         c_Data.GetWindowRect(&r);
         ScreenToClient(&r);
         c_Data.SetWindowPos(NULL, 0, 0, cx, cy - r.top, SWP_NOMOVE | SWP_NOZORDER);
        } /* resize data */
    }

/****************************************************************************
*                        CPolyDrawControlView::OnUpdate
* Inputs:
*       CView * pSender:
*       LPARAM lHint:
*       CObject * pHint:
* Result: void
*       
* Effect: 
*       Handles update requests
* Notes:
*       lHint           pHint           effect
*       -----------------------------------------------------------
*       0               NULL            ignored
*       UPDATE_ERROR    GetLastError()  Displays error
****************************************************************************/

void CPolyDrawControlView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
    {
     UNREFERENCED_PARAMETER(pSender);
     if(lHint == 0 && pHint == NULL)
        return;

     switch(lHint)
        { /* lHint */
         case CPolyDrawExplorerDoc::UPDATE_ERROR:
            { /* error */
             DWORD err = (DWORD)(UINT_PTR)pHint;
             if(err == ERROR_SUCCESS)
                c_Status.SetWindowText(_T(""));
             else
                c_Status.SetWindowText(ErrorString(err));
            } /* error */
            return;
         case CPolyDrawExplorerDoc::UPDATE_DOCUMENT:
               ItemsToDocument();
               return;
        } /* lHint */
    }
