// PolyDrawControlView.h : interface of the CPolyDrawControlView class
//


#pragma once
#include "PolyDrawCtrl.h"
#include "afxwin.h"
#include "ImageButton.h"

class CPolyDrawExplorerDoc;

class CPolyDrawControlView : public CFormView
{
protected: // create from serialization only
        CPolyDrawControlView();
        DECLARE_DYNCREATE(CPolyDrawControlView)

public:
        enum{ IDD = IDD_POLYDRAWEXPLORER_FORM };

// Attributes
public:
        CPolyDrawExplorerDoc* GetDocument() const;

// Operations
public:

// Overrides
        public:
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        virtual void OnInitialUpdate(); // called first time after construct

// Implementation
public:
        virtual ~CPolyDrawControlView();
#ifdef _DEBUG
        virtual void AssertValid() const;
        virtual void Dump(CDumpContext& dc) const;
#endif

protected:
   BYTE GetTypeFlags();
   CString GetTypeString(BYTE flags);

// Generated message map functions
protected:
        DECLARE_MESSAGE_MAP()
        void updateControls();
        BOOL Setting;
        BOOL initialized;
        void ControlsToItem(int item);
        void ItemToControls(int item);
        void UpdateSelection();
        int GetSelectedItem();
        void SwapItems(int i1, int i2);
        void ItemsToDocument();
        void DocumentToItems();
protected:
    CPolyDrawCtrl c_Data;
    CStatic c_Status;
    CButton c_LineTo;
    CButton c_MoveTo;
    CButton c_BezierTo;
    CButton c_CloseFigure;
    CImageButton c_Up;
    CImageButton c_Down;
    CEdit   c_X;
    CEdit   c_Y;
    CSpinButtonCtrl c_SpinX;
    CSpinButtonCtrl c_SpinY;
    CButton c_Add;
    CButton c_Delete;
protected:
    afx_msg void OnBnClickedAdd();
    afx_msg void OnLvnOdstatechangedData(NMHDR *pNMHDR, LRESULT *pResult);
    afx_msg void OnBnClickedMoveto();
    afx_msg void OnBnClickedLineto();
    afx_msg void OnBnClickedBezierto();
    afx_msg void OnBnClickedClosefigure();
    afx_msg void OnBnClickedUp();
    afx_msg void OnBnClickedDown();
    afx_msg void OnEnChangeX();
    afx_msg void OnEnChangeY();
    afx_msg void OnBnClickedDelete();
    afx_msg void OnLvnItemchangedData(NMHDR *pNMHDR, LRESULT *pResult);
    afx_msg void OnSize(UINT nType, int cx, int cy);
    virtual void OnUpdate(CView* /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/);
};

#ifndef _DEBUG  // debug version in PolyDrawControlView.cpp
inline CPolyDrawExplorerDoc* CPolyDrawControlView::GetDocument() const
   { return reinterpret_cast<CPolyDrawExplorerDoc*>(m_pDocument); }
#endif

