// PolyDrawExplorerDoc.h : interface of the CPolyDrawExplorerDoc class
//


#pragma once

#include "PolyDrawItem.h"

class CPolyDrawExplorerDoc : public CDocument
{
protected: // create from serialization only
        CPolyDrawExplorerDoc();
        DECLARE_DYNCREATE(CPolyDrawExplorerDoc)

// Attributes
public:

// Operations
public:

// Overrides
        public:
        virtual BOOL OnNewDocument();
        virtual void Serialize(CArchive& ar);

// Implementation
public:
        virtual ~CPolyDrawExplorerDoc();

        //****************************************************************
        // These are used for UpdateAllViews lHint values
        //****************************************************************
        static const UINT UPDATE_ERROR    = 1;
        static const UINT UPDATE_DOCUMENT = 2;
        static const UINT UPDATE_METAFILE = 3;

        //****************************************************************
        // These are used to set the size and retrieve the size for PolyDraw
        //****************************************************************
        void   SetDataSize(INT_PTR n);
        int    GetCount()                            { return (int) points.GetSize(); }

        //****************************************************************
        // These methods set and retrieve PolyDrawItem data
        // Note that before setting a value, SetDataSize must be called
        // to ensure that the constraint 0 <= i <= GetCount() - 1 is met
        //****************************************************************
        void   SetData(INT_PTR i, PolyDrawItem * pi) { points[i] = pi->pt; types[i] = pi->type; }
        PolyDrawItem * GetPolyDrawItem(INT_PTR i)    { return new PolyDrawItem(points[i], types[i]); }

        //****************************************************************
        // These methods set the active point for display
        //****************************************************************
        void   SetActive(CPoint pt)                  { active = pt;    }
        CPoint GetActive()                           { return active; }

        //****************************************************************
        // These are used to retrieve the arguments for PolyDraw
        //****************************************************************
        const CPoint * GetPoints() { return points.GetData(); }
        const LPBYTE   GetTypes()  { return types.GetData();  }

#ifdef _DEBUG
        virtual void AssertValid() const;
        virtual void Dump(CDumpContext& dc) const;
#endif

protected:
        CArray<CPoint> points;
        CArray<BYTE>   types;
        CPoint         active;
// Generated message map functions
protected:
        afx_msg void OnFileWritemetafile();
        DECLARE_MESSAGE_MAP()

};


